//////////////////////////////////////////////////////////////////////////////////////////////
// Tarn Adams makes no representations about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//////////////////////////////////////////////////////////////////////////////////////////////

#include "music_and_sound.h"

//SOUND FUNCTIONS

//SOUND
void playsound(int s)
{
	if(!musicsound.on)return;

	FSOUND_PlaySound(FSOUND_FREE,musicsound.samp[s]);
}

void initsound(void)
{
	if(!musicsound.on)return;

	musicsound.musicactive=0;
	musicsound.soundplaying=-1;
	musicsound.soundpriority=0;
	musicsound.song=-1;
	musicsound.forcesongtime=-1;

	FSOUND_SetOutput(FSOUND_OUTPUT_DSOUND);
	FSOUND_SetDriver(0);
	FSOUND_Init(44100, 32, FSOUND_INIT_USEDEFAULTMIDISYNTH);

	for(int s=0;s<SOUNDNUM;s++)
		{
		switch(s)
			{
			case SOUND_TRUMPET:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\trumpet.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_PLANE:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\plane.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SHOT1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\shot1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SHOT2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\shot2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SHOT3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\shot3.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SHOT4:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\shot4.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SCREAM1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\scream1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SCREAM2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\scream2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SCREAM3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\scream3.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SCREAM4:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\scream4.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_MGSHOT1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\mgshot1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_MGSHOT2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\mgshot2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_MGSHOT3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\mgshot3.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_MGSHOT4:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\mgshot4.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_FARMORTAR1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\farmortar1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_FARMORTAR2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\farmortar2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_FARMORTAR3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\farmortar3.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_NEARMORTAR1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\nearmortar1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_NEARMORTAR2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\nearmortar2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_NEARMORTAR3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\nearmortar3.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_GRENADE1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\grenade1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_GRENADE2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\grenade2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_GRENADE3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\grenade3.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_WOUNDED1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\wounded1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_WOUNDED2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\wounded2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_WOUNDED3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\wounded3.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_WOUNDED4:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\wounded4.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_GAS:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\gas.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SWING1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\swing1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SWING2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\swing2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_SWING3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\swing3.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_INCOMING:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\incoming.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_CHOKE1:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\choke1.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_CHOKE2:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\choke2.wav",FSOUND_NORMAL,0);
				break;
			case SOUND_CHOKE3:
				musicsound.samp[s]=FSOUND_Sample_Load(FSOUND_UNMANAGED,"sound\\choke3.wav",FSOUND_NORMAL,0);
				break;
			}

		FSOUND_Sample_SetMode(musicsound.samp[s], FSOUND_LOOP_OFF);
		}
}

void deinitsound(void)
{
	if(!musicsound.on)return;

	for(int s=0;s<SOUNDNUM;s++)
		{
		FSOUND_Sample_Free(musicsound.samp[s]);
		}

	FSOUND_Close();
}